%define mysql_version		3.23.58
%define shared_lib_version	10:0:0
%define release			2
%define mysqld_user		mysql

%define see_base For a description of MySQL see the base MySQL RPM or http://www.mysql.com

# Set 'do_bench' to 1 if you want to build the MySQL-bench package.
# By default, we skip it.
%define do_bench		0

# NOTE:  if building on 5.1.0, you need to patch /usr/include/curses.h
#  from a newer level, or the build will fail.
# The following line needs to be around the "typedef char bool;"
# declaration:
#  #if !defined(__cplusplus) || (defined(__IBMCPP__) && (__IBMCPP__<400))
#

Name: MySQL
Summary:	A very fast and reliable SQL database engine
Group:		Applications/Databases
Summary(pt_BR): Um servidor SQL rpido e confivel.
Group(pt_BR):	Aplicaes/Banco_de_Dados
Version:	%{mysql_version}
Release:	%{release}
License:	GPL / LGPL
Source:		http://www.mysql.com/Downloads/MySQL-3.23/mysql-%{mysql_version}.tar.gz
Patch0:     mysql-security.patch
Icon:		mysql.gif
URL:		http://www.mysql.com/
Provides:	msqlormysql MySQL-server
Obsoletes:	mysql
Prefix:		%{_prefix}
Prereq:		/sbin/install-info

# Think about what you use here since the first step is to
# run a rm -rf
BuildRoot:	/var/tmp/mysql-root

%define DEFCC cc

# From the manual
%description
MySQL is a true multi-user, multi-threaded SQL (Structured Query
Language) database server. MySQL is a client/server implementation
that consists of a server daemon (mysqld) and many different client
programs/libraries.

The main goals of MySQL are speed, robustness and ease of use.  MySQL
was originally developed because we needed a SQL server that could
handle very big databases with magnitude higher speed than what any
database vendor could offer to us. And since we did not need all the
features that made their server slow we made our own. We have now been
using MySQL since 1996 in a environment with more than 40 databases,
10,000 tables, of which more than 500 have more than 7 million
rows. This is about 200G of data.

The base upon which MySQL is built is a set of routines that have been
used in a highly demanding production environment for many
years. While MySQL is still in development, it already offers a rich
and highly useful function set.

See the documentation for more information

%description -l pt_BR
O MySQL  um servidor de banco de dados SQL realmente multiusurio e\
multi-tarefa. A linguagem SQL  a mais popular linguagem para banco de\
dados no mundo. O MySQL  uma implementao cliente/servidor que\
consiste de um servidor chamado mysqld e diversos\
programas/bibliotecas clientes. Os principais objetivos do MySQL so:\
velocidade, robustez e facilidade de uso.  O MySQL foi originalmente\
desenvolvido porque ns na Tcx precisvamos de um servidor SQL que\
pudesse lidar com grandes bases de dados e com uma velocidade muito\
maior do que a que qualquer vendedor podia nos oferecer. Estamos\
usando\
o MySQL desde 1996 em um ambiente com mais de 40 bases de dados com 10.000\
tabelas, das quais mais de 500 tm mais de 7 milhes de linhas. Isto  o\
equivalente a aproximadamente 50G de dados crticos. A base da construo do\
MySQL  uma srie de rotinas que foram usadas em um ambiente de produo com\
alta demanda por muitos anos. Mesmo o MySQL estando ainda em desenvolvimento,\
ele j oferece um conjunto de funes muito ricas e teis. Veja a documentao\
para maiores informaes.

%package client
Release: %{release}
Summary: MySQL - Client
Group: Applications/Databases
Summary(pt_BR): MySQL - Cliente
Group(pt_BR): Aplicaes/Banco_de_Dados
Obsoletes: mysql-client

%description client
This package contains the standard MySQL clients. 

%{see_base}

%description client -l pt_BR
Este pacote contm os clientes padro para o MySQL.

%if %{do_bench} == 1
%package bench
Release: %{release}
Requires: MySQL-client perl
Summary: MySQL - Benchmarks and test system
Group: Applications/Databases
Summary(pt_BR): MySQL - Medies de desempenho
Group(pt_BR): Aplicaes/Banco_de_Dados
Obsoletes: mysql-bench

%description bench
This package contains MySQL benchmark scripts and data.

%{see_base}

%description bench -l pt_BR
Este pacote contm medies de desempenho de scripts e dados do MySQL.
%endif

%package devel
Release: %{release}
Requires: MySQL-client
Summary: MySQL - Development header files and libraries
Group: Applications/Databases
Summary(pt_BR): MySQL - Medies de desempenho
Group(pt_BR): Aplicaes/Banco_de_Dados
Obsoletes: mysql-devel

%description devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%{see_base}

%description devel -l pt_BR
Este pacote contm os arquivos de cabealho (header files) e bibliotecas 
necessrias para desenvolver aplicaes clientes do MySQL. 

%prep
%setup -q -n mysql-%{mysql_version}
%patch0 -p1 -b .security

%build
# Use the default compiler for this platform - gcc otherwise
if [[ -z "$CC" ]]
then
    if test "X`type %{DEFCC} 2>/dev/null`" != 'X'; then
       export CC=%{DEFCC}
       export CXX=xlC
       export RPM_OPT_FLAGS=`echo $RPM_OPT_FLAGS | sed 's:-fsigned-char::'`
       export CFLAGS="$RPM_OPT_FLAGS -qcpluscmt"
    else 
       export CC="gcc -pipe -Wa,-many"
       export CXX=$CC
       export CXXFLAGS="-felide-constructors -fno-exceptions -fno-rtti"
    fi
fi
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{mysql_version}
rm -rf $RBR
mkdir -p $RBR

libtoolize --force
aclocal

./configure --prefix=%{prefix} --enable-shared --enable-thread-safe-client \
  --enable-large-files --with-low-memory --datadir=%{prefix}/share \
  --localstatedir=/var/lib/mysql  --infodir=%{prefix}/info \
  --mandir=%{prefix}/man --libexecdir=%{prefix}/libexec

#We want the 1.4.2 libtool!
cp /usr/bin/libtool ./libtool

# And now we build it all
make

%install -n mysql-%{mysql_version}
RBR=$RPM_BUILD_ROOT
MBD=$RPM_BUILD_DIR/mysql-%{mysql_version}
# Ensure that needed directories exists
install -d $RBR/etc/logrotate.d
install -d $RBR/etc/rc.d/init.d
install -d $RBR/var/lib/mysql/mysql
install -d $RBR%{prefix}/share/sql-bench
install -d $RBR%{prefix}/share/mysql-test
install -d $RBR%{prefix}/libexec
install -d $RBR%{prefix}/share
install -d $RBR%{prefix}/man
install -d $RBR%{prefix}/include
install -d $RBR%{prefix}/doc/MySQL-%{mysql_version}
install -d $RBR%{prefix}/lib
install -d $RBR%{prefix}/info
# Make install
make install DESTDIR=$RBR benchdir_root=%{prefix}/share/

# Install logrotate and autostart
install -m644 $MBD/support-files/mysql-log-rotate $RBR/etc/logrotate.d/mysql
install -m755 $MBD/support-files/mysql.server $RBR/etc/rc.d/init.d/mysql

# Install docs
gzip --best $RPM_BUILD_DIR/mysql-%{mysql_version}/Docs/mysql.info
install -m644 $RPM_BUILD_DIR/mysql-%{mysql_version}/Docs/mysql.info.gz \
 $RBR/%{prefix}/info/mysql.info.gz
rm -f $RBR/%{prefix}/info/mysql.info || :
for file in README COPYING COPYING.LIB Docs/manual_toc.html Docs/manual.html \
    Docs/manual.txt Docs/manual.texi Docs/manual.ps \
    support-files/my-huge.cnf support-files/my-large.cnf \
    support-files/my-medium.cnf support-files/my-small.cnf
do
    b=`basename $file`
    install -m644 $MBD/$file $RBR/%{prefix}/doc/MySQL-%{mysql_version}/$b
done

# Strip the binaries
strip $RPM_BUILD_ROOT%{prefix}/bin/* || :
strip $RPM_BUILD_ROOT%{prefix}/libexec/* || :

# Remove dependence on /usr/linux/bin/hostname (if present)
# in the mysql scripts.  Replace with /usr/bin/hostname.
# This way, MySQL needn't depend on sh-utils.  (This is specific to AIX Toolbox).
/usr/bin/perl -pi -e "s|/usr/linux/bin/hostname|/usr/bin/hostname|" \
  $RPM_BUILD_ROOT/etc/rc.d/init.d/mysql \
  $RPM_BUILD_ROOT%{prefix}/bin/mysql_install_db \
  $RPM_BUILD_ROOT%{prefix}/bin/safe_mysqld \

( cd $RPM_BUILD_ROOT
 mkdir -p usr/bin
 cd usr/bin
 ln -sf ../..%{prefix}/bin/* .
 cd -

 mkdir -p usr/include/mysql
 cd usr/include/mysql
 ln -sf ../../..%{prefix}/include/mysql/* .
 cd -

 mkdir -p usr/lib/mysql
 cd usr/lib/mysql
 ln -sf ../../..%{prefix}/lib/mysql/* .
 cd -
)


%pre
if test -x /etc/rc.d/init.d/mysql
then
  /etc/rc.d/init.d/mysql stop > /dev/null 2>&1
  echo "Giving mysqld a couple of seconds to exit nicely"
  sleep 5
fi

%post
/sbin/install-info --quiet --info-dir=%{_prefix}/info %{_prefix}/info/mysql.info.gz

mysql_datadir=/var/lib/mysql

# Create data directory if needed
if test ! -d $mysql_datadir;		then mkdir $mysql_datadir; fi
if test ! -d $mysql_datadir/mysql;	then mkdir $mysql_datadir/mysql; fi
if test ! -d $mysql_datadir/test;	then mkdir $mysql_datadir/test; fi

mkuser -a home=$mysql_datadir gecos="MySQL server" mysql 2>/dev/null || true

# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R mysql $mysql_datadir

# Initiate databases
mysql_install_db -IN-RPM --ldata=$mysql_datadir

# Change permissions again to fix any new files.
chown -R mysql $mysql_datadir

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw $mysql_datadir/mysql

# Restart in the same way that mysqld will be started normally.
/etc/rc.d/init.d/mysql start >/dev/null 2>&1 

# Allow safe_mysqld to start mysqld and print a message before we exit
sleep 2

%preun
if [ $1 = 0 ]; then
  /sbin/install-info --quiet --info-dir=%{_prefix}/info --delete %{_prefix}/info/mysql.info.gz
fi

if test -x /etc/rc.d/init.d/mysql
then
  /etc/rc.d/init.d/mysql stop > /dev/null
fi

%files
%defattr(-, root, system)
%attr(-, root, system) %doc %{prefix}/doc/MySQL-%{mysql_version}/

%attr(755, root, system) %{prefix}/bin/isamchk
%attr(755, root, system) %{prefix}/bin/isamlog
%attr(755, root, system) %{prefix}/bin/pack_isam
%attr(755, root, system) %{prefix}/bin/myisamchk
%attr(755, root, system) %{prefix}/bin/myisamlog
%attr(755, root, system) %{prefix}/bin/myisampack
%attr(755, root, system) %{prefix}/bin/mysql_fix_privilege_tables
%attr(755, root, system) %{prefix}/bin/mysql_convert_table_format
%attr(755, root, system) %{prefix}/bin/mysql_install_db
%attr(755, root, system) %{prefix}/bin/mysql_setpermission
%attr(755, root, system) %{prefix}/bin/mysql_zap
%attr(755, root, system) %{prefix}/bin/mysqlbug
%attr(755, root, system) %{prefix}/bin/mysqltest
%attr(755, root, system) %{prefix}/bin/mysqlhotcopy
%attr(755, root, system) %{prefix}/bin/perror
%attr(755, root, system) %{prefix}/bin/replace
%attr(755, root, system) %{prefix}/bin/resolveip
%attr(755, root, system) %{prefix}/bin/safe_mysqld
%attr(755, root, system) %{prefix}/bin/mysqld_multi
%attr(755, root, system) %{prefix}/bin/my_print_defaults
%attr(755, root, system) %{prefix}/bin/mysqldumpslow
%attr(755, root, system) %{prefix}/bin/mysqlcheck
%attr(755, root, system) %{prefix}/bin/resolve_stack_dump
%attr(755, root, system) /usr/bin/isamchk
%attr(755, root, system) /usr/bin/isamlog
%attr(755, root, system) /usr/bin/pack_isam
%attr(755, root, system) /usr/bin/myisamchk
%attr(755, root, system) /usr/bin/myisamlog
%attr(755, root, system) /usr/bin/myisampack
%attr(755, root, system) /usr/bin/mysql_fix_privilege_tables
%attr(755, root, system) /usr/bin/mysql_convert_table_format
%attr(755, root, system) /usr/bin/mysql_install_db
%attr(755, root, system) /usr/bin/mysql_setpermission
%attr(755, root, system) /usr/bin/mysql_zap
%attr(755, root, system) /usr/bin/mysqlbug
%attr(755, root, system) /usr/bin/mysqltest
%attr(755, root, system) /usr/bin/mysqlhotcopy
%attr(755, root, system) /usr/bin/perror
%attr(755, root, system) /usr/bin/replace
%attr(755, root, system) /usr/bin/resolveip
%attr(755, root, system) /usr/bin/safe_mysqld
%attr(755, root, system) /usr/bin/mysqld_multi
%attr(755, root, system) /usr/bin/my_print_defaults
%attr(755, root, system) /usr/bin/mysqldumpslow
%attr(755, root, system) /usr/bin/mysqlcheck
%attr(755, root, system) /usr/bin/resolve_stack_dump

%attr(644, root, system) %{prefix}/info/mysql.info.gz

%attr(755, root, system) %{prefix}/libexec/mysqld

%attr(644, root, system) /etc/logrotate.d/mysql
%attr(755, root, system) /etc/rc.d/init.d/mysql

%attr(755, root, system) %{prefix}/share/mysql/

%files client
%defattr(-, root, system)
%attr(755, root, system) %{prefix}/bin/msql2mysql
%attr(755, root, system) %{prefix}/bin/mysql
%attr(755, root, system) %{prefix}/bin/mysqlaccess
%attr(755, root, system) %{prefix}/bin/mysqladmin
%attr(755, root, system) %{prefix}/bin/mysql_find_rows
%attr(755, root, system) %{prefix}/bin/mysqldump
%attr(755, root, system) %{prefix}/bin/mysqlimport
%attr(755, root, system) %{prefix}/bin/mysqlshow
%attr(755, root, system) %{prefix}/bin/mysqlbinlog
%attr(755, root, system) %{prefix}/lib/mysql/libmysqlclient.a
%attr(755, root, system) %{prefix}/lib/mysql/libmysqlclient_r.a
%attr(755, root, system) /usr/bin/msql2mysql
%attr(755, root, system) /usr/bin/mysql
%attr(755, root, system) /usr/bin/mysqlaccess
%attr(755, root, system) /usr/bin/mysqladmin
%attr(755, root, system) /usr/bin/mysql_find_rows
%attr(755, root, system) /usr/bin/mysqldump
%attr(755, root, system) /usr/bin/mysqlimport
%attr(755, root, system) /usr/bin/mysqlshow
%attr(755, root, system) /usr/bin/mysqlbinlog
%attr(755, root, system) /usr/lib/mysql/libmysqlclient.a
%attr(755, root, system) /usr/lib/mysql/libmysqlclient_r.a

%attr(644, root, system) %doc %{prefix}/man/man1/mysql.1*
%attr(644, root, system) %doc %{prefix}/man/man1/isamchk.1*
%attr(644, root, system) %doc %{prefix}/man/man1/isamlog.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysql_zap.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysqlaccess.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysqladmin.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysqld.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysqld_multi.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysqldump.1*
%attr(644, root, system) %doc %{prefix}/man/man1/mysqlshow.1*
%attr(644, root, system) %doc %{prefix}/man/man1/perror.1*
%attr(644, root, system) %doc %{prefix}/man/man1/replace.1*
%attr(644, root, system) %doc %{prefix}/man/man1/safe_mysqld.1*

%files devel
%defattr(-, root, system)
%attr(755, root, system) %{prefix}/bin/comp_err
%attr(755, root, system) %{prefix}/bin/mysql_config
%attr(755, root, system) %{prefix}/include/mysql/
%attr(755, root, system) %{prefix}/lib/mysql/libdbug.a
%attr(755, root, system) %{prefix}/lib/mysql/libheap.a
%attr(755, root, system) %{prefix}/lib/mysql/libmerge.a
%attr(755, root, system) %{prefix}/lib/mysql/libmyisam.a
%attr(755, root, system) %{prefix}/lib/mysql/libmyisammrg.a
%attr(755, root, system) %{prefix}/lib/mysql/libmystrings.a
%attr(755, root, system) %{prefix}/lib/mysql/libmysys.a
%attr(755, root, system) %{prefix}/lib/mysql/libnisam.a
%attr(755, root, system) /usr/bin/comp_err
%attr(755, root, system) /usr/bin/mysql_config
%attr(755, root, system) /usr/include/mysql/
%attr(755, root, system) /usr/lib/mysql/libdbug.a
%attr(755, root, system) /usr/lib/mysql/libheap.a
%attr(755, root, system) /usr/lib/mysql/libmerge.a
%attr(755, root, system) /usr/lib/mysql/libmyisam.a
%attr(755, root, system) /usr/lib/mysql/libmyisammrg.a
%attr(755, root, system) /usr/lib/mysql/libmystrings.a
%attr(755, root, system) /usr/lib/mysql/libmysys.a
%attr(755, root, system) /usr/lib/mysql/libnisam.a
%attr(755, root, system) %{prefix}/lib/mysql/*.la
%attr(755, root, system) /usr/lib/mysql/*.la

%if %{do_bench} == 1
%files bench
%defattr(-, root, system)
%attr(-, root, system) %{prefix}/share/sql-bench
%attr(-, root, system) %{prefix}/share/mysql-test
%endif

%changelog 
* Thu May 06 2004 Philip K. Warren <pkw@us.ibm.com> 3.23.58-2
- Apply security fixes for CAN-2004-0381 and CAN-2004-0388.

* Mon Nov 24 2003  David Clissold <cliss@austin.ibm.com> 3.23.58-1
- Update to 3.23.58

* Mon Nov 24 2003  David Clissold <cliss@austin.ibm.com> 3.23.55-2
- Strip mysqld; gzip mysql.info; install-info mysql.info.

* Tue Nov 04 2003  David Clissold <cliss@austin.ibm.com>
- Update to version 3.23.55

* Fri Mar 14 2003  David Clissold <cliss@austin.ibm.com>
- redirect "mysql start" postinst output to /dev/null; don't want children
- daemons to keep file descriptors open during install. (otherwise if piped,
- pipe will not close).
- ALSO: now build with VAC C compiler by default (smaller & faster).

* Thu Feb 13 2003  David Clissold <cliss@austin.ibm.com>
- See (Thu Oct 11 2001) below.  Remove sh-utils dependency entirely
- by using native AIX /usr/bin/hostname in the req'd scripts.

* Fri Feb 08 2002  David Clissold <cliss@austin.ibm.com>
- Update to level 3.23.47

* Mon Nov 05 2001  David Clissold <cliss@austin.ibm.com>
- Update to level 3.23.44

* Thu Oct 11 2001  David Clissold <cliss@austin.ibm.com>
- Add an explicit requires for sh-utils (%post script runs
- /usr/linux/bin/hostname)

* Mon Oct 08 2001  David Clissold <cliss@austin.ibm.com>
- Update to level 3.23.43

* Wed Sep 12 2001  David Clissold <cliss@austin.ibm.com>
- Update to level 3.23.42

* Wed Jul 11 2001  David Clissold <cliss@austin.ibm.com>
- Initial build for AIX Toolbox

* Tue Jan 2  2001  Monty
- Added mysql-test to the bench package

* Fri Aug 18 2000 Tim Smith <tim@mysql.com>
- Added separate libmysql_r directory; now both a threaded
  and non-threaded library is shipped.

* Wed Sep 28 1999 David Axmark <davida@mysql.com>
- Added the support-files/my-example.cnf to the docs directory.
- Removed devel dependency on base since it is about client
  development.

* Wed Sep 8 1999 David Axmark <davida@mysql.com>
- Cleaned up some for 3.23.

* Thu Jul 1 1999 David Axmark <davida@mysql.com>
- Added support for shared libraries in a separate sub
  package. Original fix by David Fox (dsfox@cogsci.ucsd.edu)
- The --enable-assembler switch is now automatically disables on
  platforms there assembler code is unavailable. This should allow
  building this RPM on non i386 systems.

* Mon Feb 22 1999 David Axmark <david@detron.se>
- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.
- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.
- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>
- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>
- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.
